
#pragma comment(lib, "libSDLx.lib")
#pragma comment(lib, "SDL_Image.lib")
#pragma comment(lib, "SDL_ttf.lib")

#include "main.h"
#include "xtl.h"


LAUNCH_DATA LaunchData = { LDT_TITLE };
void load_settings();

//extern uint8 romdisk[];
//KOS_INIT_ROMDISK(romdisk);

extern SDL_Surface *screen;
extern int keyboard[];

GAMESTATE state;
GAMESTATE laststate;

int score;
int lives;
int volume=2; /* 0-3 */
int difficulty=DIFF_EASY;
Mix_Music *menu=NULL;
Mix_Music *ingame=NULL;
Mix_Chunk *sample[5];

int menumus = 0;
int ingamemus = 0;
int playing = 0;

int flickerlevel;
	int xpos;
	int ypos;
	int xstretch;
	int ystretch;

	FILE *config;


int main(int argc, char *argv[])
{
	

	game_init(argc, argv);
	load_settings();


	SDL_Init(SDL_INIT_AUDIO);
	Mix_OpenAudio(44100, MIX_DEFAULT_FORMAT, 2, 2048);
	menu=Mix_LoadMUS("d:\\rd\\mod.knulla-kuk.mod");
	ingame=Mix_LoadMUS("d:\\rd\\civilian.ogg");

	Mix_VolumeMusic(MIX_MAX_VOLUME);
	

	while (state.mainstate!=ST_GAME_QUIT) {
		keyboard_poll();

		switch(state.mainstate) {
			case ST_START_INTRO:
				if(state.newstate) {
					startintro_init();
					state.newstate=0;
				}
				startintro_work();
				break;
			case ST_INTRO:
				if(state.newstate) {
					intro_init();
					state.newstate=0;
				}
				intro_work();
				break;
			case ST_GAME_PLAY:
				if(state.newstate) {
					thegame_init();
					state.newstate=0;
					if(menumus == 1 && ingamemus == 0){
					Mix_FadeInMusic(ingame,-1,2000);
					menumus = 0;
					}
				}
				thegame_work();
				break;
			case ST_GAME_OVER:
				if(state.newstate) {
					gameover_init();
					state.newstate=0;
				}
				gameover_work();
				break;
			case ST_MENU:
				if(state.newstate) {
					menu_init();
					state.newstate=0;
					if(menumus == 0 || ingamemus == 1){
					Mix_FadeOutMusic(1000);
					Mix_FadeInMusic(menu,-1,2000);
					menumus = 1;
					}

				}
				menu_work();
				break;
			case ST_SHOW_HCLIST:
				if(state.newstate) {
					hsc_show_init();
					state.newstate=0;
				}
				hsc_show_work();
				break;
			case ST_ENTRY_HCLIST:
				if(state.newstate) {
					hsc_entry_init();
					state.newstate=0;
				}
				hsc_entry_work();
				break;
		}
		
		fps_show();

		SDL_Flip(screen);
		fps_newframe();
	}

	/* TODO: Free everything (memory, SDL_Surfaces, Joysticks...) */

	//fprintf(stdout,"Thank you for playing\n");

	XLaunchNewImage(NULL, (LAUNCH_DATA*)&LaunchData );
	exit(0);
}


void load_settings(void)
{

extern LPDIRECT3DDEVICE8 D3D_Device;
//Open the config file.
config=fopen("D:\\config.cfg", "r");
fread(&xpos, sizeof(int), 1,config);
fread(&ypos, sizeof(int), 1, config);
fread(&xstretch, sizeof(int), 1, config);
fread(&ystretch, sizeof(int), 1, config);
fread(&flickerlevel, sizeof(int), 1, config);
fclose(config);

//now do the stuff
//D3D_Device->SetFlickerFilter(flickerlevel);
//now resize our screen
SDL_XBOX_SetScreenPosition(xpos,ypos);
SDL_XBOX_SetScreenStretch(xstretch,ystretch);
}

